-- This file is generated by the scripts in rvex-hdl.git/cgen/bin. --

-- r-VEX processor                                                                                   -- GENERATED --
-- Copyright (C) 2008-2018 by TU Delft.
-- All Rights Reserved.

-- THIS IS A LEGAL DOCUMENT, BY USING r-VEX,
-- YOU ARE AGREEING TO THESE TERMS AND CONDITIONS.

-- No portion of this work may be used by any commercial entity, or for any
-- commercial purpose, without the prior, written permission of TU Delft.
-- Nonprofit and noncommercial use is permitted as described below.
                                                                                                     -- GENERATED --
-- 1. r-VEX is provided AS IS, with no warranty of any kind, express
-- or implied. The user of the code accepts full responsibility for the
-- application of the code and the use of any results.

-- 2. Nonprofit and noncommercial use is encouraged. r-VEX may be
-- downloaded, compiled, synthesized, copied, and modified solely for nonprofit,
-- educational, noncommercial research, and noncommercial scholarship
-- purposes provided that this notice in its entirety accompanies all copies.
-- Copies of the modified software can be delivered to persons who use it
-- solely for nonprofit, educational, noncommercial research, and                                    -- GENERATED --
-- noncommercial scholarship purposes provided that this notice in its
-- entirety accompanies all copies.

-- 3. ALL COMMERCIAL USE, AND ALL USE BY FOR PROFIT ENTITIES, IS EXPRESSLY
-- PROHIBITED WITHOUT A LICENSE FROM TU Delft (J.S.S.M.Wong@tudelft.nl).

-- 4. No nonprofit user may place any restrictions on the use of this software,
-- including as modified by the user, by any other authorized user.

-- 5. Noncommercial and nonprofit users may distribute copies of r-VEX                               -- GENERATED --
-- in compiled or binary form as set forth in Section 2, provided that
-- either: (A) it is accompanied by the corresponding machine-readable source
-- code, or (B) it is accompanied by a written offer, with no time limit, to
-- give anyone a machine-readable copy of the corresponding source code in
-- return for reimbursement of the cost of distribution. This written offer
-- must permit verbatim duplication by anyone, or (C) it is distributed by
-- someone who received only the executable form, and is accompanied by a
-- copy of the written offer of source code.

-- 6. r-VEX was developed by Stephan Wong, Thijs van As, Fakhar Anjam,                               -- GENERATED --
-- Roel Seedorf, Anthony Brandon, Jeroen van Straten. r-VEX is currently
-- maintained by TU Delft (J.S.S.M.Wong@tudelft.nl).

-- Copyright (C) 2008-2018 by TU Delft.

library IEEE;
use IEEE.std_logic_1164.all;

--=============================================================================
-- This package configures the pipeline used by the rvex.                                            -- GENERATED --
-------------------------------------------------------------------------------
package core_pipeline_pkg is
--=============================================================================

  -----------------------------------------------------------------------------
  -- Pipeline diagram
  -----------------------------------------------------------------------------
  -- The figure below shows the pipeline diagram and forwarding logic of the
  -- rvex processor. Pipeline flushing due to exceptions and limmh forwarding
  -- is not shown. Timing within the stages is approximate.                                          -- GENERATED --
  --
  -- . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
  --
  --              clk        clk        clk        clk        clk
  --    :----S1----:----S2----:----S3----:----S4----:----S5----:----S6----:
  --    :    .---------..----.:      .-------..---------.   .-----.       :
  --    :    |  IMEM   ||Btgt|:      |  ALU  ||  DMEM   |   |Reg. |       :
  --    :    '---------''----':      '-------''---------'   |write|       :
  --    :    .----.:       .-----.   .------------------.   '-----'       :
  --    :    |PC+1|:       |Reg. |   |   :   MUL    :   |      :          :                          -- GENERATED --
  --    :    '----':       |read |   '------------------'      :          :
  --    :          :       '-----'       :    .---. :          :          :
  --    :          :    .-..-.:          :    |BRK| :          :          :
  --    :          :    |s||l|:          :    '---' :          :          :
  --    :          :    |t||i|:          :          :          :          :
  --    :          :    |o||m|:          :          :          :          :
  --    :          :    |p||m|:          :          :          :          :
  --    :          :    '-''-':          :          :          :          :
  --    '----S1----'----S2----'----S3----'----S4----'----S5----'----S6----'
  --         ^           |      |   ^        |          |          |*                                -- GENERATED --
  --         |           v      v   |        v          v          v
  --        .--------------------. .--------------------------------.
  --        |    Branch unit     | |General purpose reg. forwarding |
  --        '--------------------' '--------------------------------'
  --     ----S1---- ----S2---- ----S3---- ----S4---- ----S5---- ----S6----
  --                         ^    ^         |          |      |
  --                         |    |         v          v      |
  --                         |   .----------------------.     |
  --                         |   |Branch & link forward.|     |
  --                         |   '----------------------'     |                                      -- GENERATED --
  --                         |                                |
  --                         '--------------------------------'
  --                                  Trap forwarding
  --
  -- * The register file is implemented using dual port RAM blocks. These
  --   blocks do not have consistent read-while-write behavior between the two
  --   ports. By extending the forwarding logic by one stage, such accesses are
  --   prevented (at least, their result is ignored).
  --
                                                                                                     -- GENERATED --
  -- TODO: generate something like the diagram above.

  -----------------------------------------------------------------------------
  -- Pipeline definitions
  -----------------------------------------------------------------------------
  -- The S_<block> definitions map to the first stage of a block. The L_<block>
  -- definitions determine the latency of a block, i.e., how many stages later
  -- the results of a block are expected to be valid.

  constant L_ALU                : natural := 1;                                                      -- GENERATED --
  constant L_ALU1               : natural := 0;
  constant L_ALU2               : natural := 1;
  constant L_BRK                : natural := 0;
  constant L_FADD               : natural := 1;
  constant L_FADD1              : natural := 0;
  constant L_FADD2              : natural := 0;
  constant L_FADD3              : natural := 1;
  constant L_FCIF               : natural := 1;
  constant L_FCIF1              : natural := 0;
  constant L_FCIF2              : natural := 1;                                                      -- GENERATED --
  constant L_FCMP               : natural := 1;
  constant L_FCMP1              : natural := 0;
  constant L_FCMP2              : natural := 1;
  constant L_FMUL               : natural := 1;
  constant L_FMUL1              : natural := 0;
  constant L_FMUL2              : natural := 1;
  constant L_FMUL3              : natural := 0;
  constant L_IF                 : natural := 1;
  constant L_IF_MEM             : natural := 1;
  constant L_MEM                : natural := 1;                                                      -- GENERATED --
  constant L_MUL                : natural := 2;
  constant L_MUL1               : natural := 1;
  constant L_MUL2               : natural := 1;
  constant L_RD                 : natural := 1;
  constant L_WB                 : natural := 1;
  constant S_ALU                : natural := 3;
  constant S_BR                 : natural := 3;
  constant S_BRK                : natural := 4;
  constant S_BTGT               : natural := 2;
  constant S_FADD               : natural := 3;                                                      -- GENERATED --
  constant S_FCFI               : natural := 3;
  constant S_FCIF               : natural := 3;
  constant S_FCMP               : natural := 3;
  constant S_FIRST              : natural := 1;
  constant S_FMUL               : natural := 3;
  constant S_FW                 : natural := 3;
  constant S_IF                 : natural := 1;
  constant S_LAST               : natural := 6;
  constant S_LIMM               : natural := 2;
  constant S_LTRP               : natural := 5;                                                      -- GENERATED --
  constant S_MEM                : natural := 4;
  constant S_MUL                : natural := 3;
  constant S_PCP1               : natural := 1;
  constant S_RD                 : natural := 2;
  constant S_SFW                : natural := 3;
  constant S_SRD                : natural := 3;
  constant S_STOP               : natural := 2;
  constant S_SWB                : natural := 5;
  constant S_TRAP               : natural := 2;
  constant S_WB                 : natural := 5;                                                      -- GENERATED --

end core_pipeline_pkg;

package body core_pipeline_pkg is
end core_pipeline_pkg;
