#ifndef _ASM_ST200_PCI_H
#define _ASM_ST200_PCI_H

#ifdef __KERNEL__

#include <linux/mm.h>
#include <asm/scatterlist.h>

#define pcibios_assign_all_busses()     1

/* Defined in board or soc layer */
extern const unsigned long PCIBIOS_MIN_IO, PCIBIOS_MIN_MEM;

/* Global pointer to base of memory mapped IO region */
extern void *pcibios_io_region;

/* We only support one pci controller at the moment */
extern struct pci_ops *pcibios_pci_ops;

/* The PCI address space does equal the physical memory
 * address space.  The networking and block device layers use
 * this boolean for bounce buffer decisions.
 */
#define PCI_DMA_BUS_IS_PHYS     (1)

void pcibios_set_master(struct pci_dev *dev);

/* Gives us the slot to irq number mapping */
int pcibios_map_platform_irq(struct pci_dev *dev, u8 slot, u8 pin);

#endif /* __KERNEL__ */

/* implement the pci_ DMA API in terms of the generic device dma_ one */
#include <asm-generic/pci-dma-compat.h>

/* generic pci stuff */
#include <asm-generic/pci.h>

#endif /* _ASM_ST200_PCI_H */
