/*
 * include/asm-st200/ipcbuf.h
 */

#ifndef _ASM_ST200_IPCBUF_H
#define _ASM_ST200_IPCBUF_H

/*
 * The ipc64_perm structure for ST200 architecture.
 * Note extra padding because this structure is passed back and forth
 * between kernel and user space.
 *
 * Pad space is left for:
 * - 32-bit seq
 * - 2 miscellaneous 32-bit values
 */

struct ipc64_perm {
	__kernel_key_t key;
	__kernel_uid32_t uid;
	__kernel_gid32_t gid;
	__kernel_uid32_t cuid;
	__kernel_gid32_t cgid;
	__kernel_mode_t mode;
	unsigned short seq;
	unsigned short __pad1;
	unsigned long __unused1;
	unsigned long __unused2;
};

#endif /* _ASM_ST200_IPCBUF_H */
