/*
 *  include/asm-st200/unistd.h
 *
 *  Copyright (C) 2002 STMicroelectronics Limited
 *	Author: David McKay <david.mckay@st.com>
 *
 */

#ifndef _ASM_ST200_UNISTD_H
#define _ASM_ST200_UNISTD_H

/*
 * This file contains the system call numbers.
 */

#define __NR_syscall                0
#define __NR_exit                   1
#define __NR_read                   2
#define __NR_write                  3
#define __NR_open                   4
#define __NR_close                  5
#define __NR_link                   6
#define __NR_unlink                 7
#define __NR_execve                 8
#define __NR_chdir                  9
#define __NR_mknod                 10
#define __NR_chmod                 11
#define __NR_lchown                12
#define __NR_socket                13
#define __NR_stat                  14
#define __NR_lseek                 15
#define __NR_getpid                16
#define __NR_mount                 17
#define __NR_bind                  18
#define __NR_setuid                19
#define __NR_getuid                20
#define __NR_ptrace                21
#define __NR_fstat                 22
#define __NR_utimes                23
#define __NR_connect               24
#define __NR_listen                25
#define __NR_access                26
#define __NR_accept                27
#define __NR_sync                  28
#define __NR_kill                  29
#define __NR_rename                30
#define __NR_mkdir                 31
#define __NR_rmdir                 32
#define __NR_dup                   33
#define __NR_pipe                  34
#define __NR_times                 35
#define __NR_getsockname           36
#define __NR_brk                   37
#define __NR_setgid                38
#define __NR_getgid                39
#define __NR_geteuid               40
#define __NR_getegid               41
#define __NR_acct                  42
#define __NR_umount2               43
#define __NR_getpeername           44
#define __NR_ioctl                 45
#define __NR_fcntl                 46
#define __NR_socketpair            47
#define __NR_setpgid               48
#define __NR_send                  49
#define __NR_uname                 50
#define __NR_umask                 51
#define __NR_chroot                52
#define __NR_ustat                 53
#define __NR_dup2                  54
#define __NR_getppid               55
#define __NR_setsid                56
#define __NR_pivot_root            57
#define __NR_setreuid              58
#define __NR_setregid              59
#define __NR_mincore               60
#define __NR_sethostname           61
#define __NR_setrlimit             62
#define __NR_getrlimit             63
#define __NR_getrusage             64
#define __NR_gettimeofday          65
#define __NR_settimeofday          66
#define __NR_getgroups             67
#define __NR_setgroups             68
#define __NR_sendto                69
#define __NR_symlink               70
#define __NR_lstat                 71
#define __NR_readlink              72
#define __NR_uselib                73
#define __NR_swapon                74
#define __NR_reboot                75
#define __NR_mmap2                 76
#define __NR_munmap                77
#define __NR_truncate              78
#define __NR_ftruncate             79
#define __NR_fchmod                80
#define __NR_fchown                81
#define __NR_getpriority           82
#define __NR_setpriority           83
#define __NR_recv                  84
#define __NR_statfs                85
#define __NR_fstatfs               86
#define __NR_stat64                87
#define __NR_syslog                88
#define __NR_setitimer             89
#define __NR_getitimer             90
#define __NR_capget                91
#define __NR_capset                92
#define __NR_pread64               93
#define __NR_pwrite64              94
#define __NR_getcwd                95
#define __NR_vhangup               96
#define __NR_fstat64               97
#define __NR_wait4                 98
#define __NR_swapoff               99
#define __NR_sysinfo              100
#define __NR_shutdown             101
#define __NR_fsync                102
#define __NR_madvise              103
#define __NR_clone                104
#define __NR_setdomainname        105
#define __NR_sendfile             106
#define __NR_recvfrom             107
#define __NR_adjtimex             108
#define __NR_mprotect             109
#define __NR_init_module          110
#define __NR_delete_module        111
#define __NR_quotactl             112
#define __NR_getpgid              113
#define __NR_fchdir               114
#define __NR_bdflush              115
#define __NR_sysfs                116
#define __NR_personality          117
#define __NR_setfsuid             118
#define __NR_setfsgid             119
#define __NR__llseek              120
#define __NR_getdents             121
#define __NR__newselect           122
#define __NR_flock                123
#define __NR_msync                124
#define __NR_readv                125
#define __NR_writev               126
#define __NR_getsid               127
#define __NR_fdatasync            128
#define __NR__sysctl              129
#define __NR_mlock                130
#define __NR_munlock              131
#define __NR_mlockall             132
#define __NR_munlockall           133
#define __NR_sched_setparam               134
#define __NR_sched_getparam               135
#define __NR_sched_setscheduler           136
#define __NR_sched_getscheduler           137
#define __NR_sched_yield                  138
#define __NR_sched_get_priority_max       139
#define __NR_sched_get_priority_min       140
#define __NR_sched_rr_get_interval        141
#define __NR_nanosleep            142
#define __NR_mremap               143
#define __NR_setresuid            144
#define __NR_getresuid            145
#define __NR_sigaltstack          146
#define __NR_poll                 147
#define __NR_nfsservctl           148
#define __NR_setresgid            149
#define __NR_getresgid            150
#define __NR_prctl                151
#define __NR_rt_sigreturn         152
#define __NR_rt_sigaction         153
#define __NR_rt_sigprocmask       154
#define __NR_rt_sigpending        155
#define __NR_rt_sigtimedwait      156
#define __NR_rt_sigqueueinfo      157
#define __NR_rt_sigsuspend        158
#define __NR_chown                159
#define __NR_setsockopt           160
#define __NR_getsockopt           161
#define __NR_sendmsg              162
#define __NR_recvmsg              163
#define __NR_semop                164
#define __NR_semget               165
#define __NR_semctl               166
#define __NR_msgsnd               167
#define __NR_msgrcv               168
#define __NR_msgget               169
#define __NR_msgctl               170
#define __NR_shmat                171
#define __NR_shmdt                172
#define __NR_shmget               173
#define __NR_shmctl               174
#define __NR_lstat64              175
#define __NR_truncate64           176
#define __NR_ftruncate64          177
#define __NR_getdents64           178
#define __NR_fcntl64              179
#define __NR_gettid               180
#define __NR_readahead            181
#define __NR_setxattr             182
#define __NR_lsetxattr            183
#define __NR_fsetxattr            184
#define __NR_getxattr             185
#define __NR_lgetxattr            186
#define __NR_fgetxattr            187
#define __NR_listxattr            188
#define __NR_llistxattr           189
#define __NR_flistxattr           190
#define __NR_removexattr          191
#define __NR_lremovexattr         192
#define __NR_fremovexattr         193
#define __NR_sendfile64           194
#define __NR_tkill		  195
#define __NR_tgkill               196
#define __NR_restart_syscall	  197
#define __NR_semtimedop           198
#define __NR_set_tid_address      199
#define __NR_sched_setaffinity    200
#define __NR_sched_getaffinity    201
#define __NR_futex                202
#define __NR_exit_group           203
#define __NR_io_setup             204
#define __NR_io_destroy           205
#define __NR_io_getevents         206
#define __NR_io_submit         	  207
#define __NR_io_cancel        	  208
#define __NR_lookup_dcookie 	  209
#define __NR_epoll_create         210
#define __NR_epoll_ctl            211
#define __NR_epoll_wait		  212
#define __NR_mbind		  213
#define __NR_get_mempolicy	  214
#define __NR_set_mempolicy        215
#define __NR_remap_file_pages     216
#define __NR_fadvise64_64 	  217
#define __NR_statfs64		  218
#define __NR_fstatfs64 		  219
#define __NR_waitid 	          220
#define __NR_mq_open              221
#define __NR_mq_unlink            222
#define __NR_mq_timedsend         223
#define __NR_mq_timedreceive      224
#define __NR_mq_notify            225
#define __NR_mq_getsetattr        226
#define __NR_timer_create         227
#define __NR_timer_settime        228
#define __NR_timer_gettime        229
#define __NR_timer_getoverrun     230
#define __NR_timer_delete         231
#define __NR_clock_settime        232
#define __NR_clock_gettime        233
#define __NR_clock_getres         234
#define __NR_clock_nanosleep      235
#define __NR_sys_kexec_load       236
#define __NR_add_key              237
#define __NR_request_key          238
#define __NR_keyctl               239

#define __NR_Linux_syscalls       240

#ifndef __ASSEMBLY__

#define __syscall_return(type)			\
do {					        \
	if(_sc_err) {errno=_sc_res;_sc_res=-1;}	\
	return (type) (_sc_res); \
} while (0)

#define __syscall_clobber                                         \
                       "memory",                                        \
                       "r8",  "r9",  "r10", "r11",               	\
                                                                 "r23",	\
                       "r24", "r25", "r26", "r27", "r28", "r29", "r30", \
                       "r31", "r32", "r33", "r34", "r35", "r36", "r37", \
                       "r38", "r39", "r40", "r41", "r42", "r43", "r44", \
                       "r45", "r46", "r47", "r48", "r49", "r50", "r51", \
                       "r52", "r53", "r54", "r55", "r56", "r57", "r58", \
                       "r59", "r60", "r61", "r62",                      \
                       "b0", "b1", "b2", "b3", "b4", "b5", "b6", "b7"

#define __syscall_input0 "r" (_sc_num)
#define __syscall_input1 __syscall_input0,"r" (_sc_arg1)
#define __syscall_input2 __syscall_input1,"r" (_sc_arg2)
#define __syscall_input3 __syscall_input2,"r" (_sc_arg3)
#define __syscall_input4 __syscall_input3,"r" (_sc_arg4)
#define __syscall_input5 __syscall_input4,"r" (_sc_arg5)
#define __syscall_input6 __syscall_input5,"r" (_sc_arg6)

#define _syscall0(type,name)			\
type name(void)                                 \
{                                               \
	register long _sc_num asm("r15");       \
	register long _sc_res;			\
	register long _sc_err;			\
        _sc_num = __NR_##name;			\
	__asm__ volatile ("syscall 0 \n"	\
			  ";; \n"		\
			  "mfb %0 = $b0 \n"	\
			  "mov %1 = $r16\n"     \
			  ";;\n"		\
			  :"=r" (_sc_err),"=r" (_sc_res) \
			  : __syscall_input0    \
                          : __syscall_clobber, "r16","r17","r18","r19","r20","r21","r22");	\
	__syscall_return(type);			\
}

#define _syscall1(type,name,type1,arg1)		\
type name(type1 arg1)                           \
{                                               \
	register long _sc_num asm("r15");	\
	register long _sc_res;	                \
	register long _sc_arg1 asm("r16");	\
	register long _sc_err;			\
        _sc_num = __NR_##name;			\
	_sc_arg1 = (long)arg1;			\
	__asm__ volatile ("syscall 0 \n"	\
			  ";; \n"		\
			  "mfb %0 = $b0 \n"	\
			  "mov %1 = $r16\n"     \
			  ";;\n"	        \
			  :"=r" (_sc_err),"=r" (_sc_res)    \
			  : __syscall_input1    \
                          : __syscall_clobber,"r17","r18","r19","r20","r21","r22" );	\
	__syscall_return(type);	                \
}

#define _syscall2(type,name,type1,arg1,type2,arg2)	\
type name(type1 arg1,type2 arg2)    		        \
{                                                       \
	register long _sc_num asm("r15");		\
	register long _sc_res;				\
	register long _sc_arg1 asm("r16");		\
	register long _sc_arg2 asm("r17");		\
	register long _sc_err;		                \
        _sc_num = __NR_##name;				\
	_sc_arg1 = (long)arg1;                          \
	_sc_arg2 = (long)arg2;                          \
	__asm__ volatile ("syscall 0 \n"		\
			  ";; \n"			\
			  "mfb %0 = $b0 \n"		\
			  "mov %1 = $r16\n"		\
			  ";;\n"			\
			  :"=r" (_sc_err),"=r" (_sc_res)	\
                          : __syscall_input2             \
			  : __syscall_clobber,"r18","r19","r20","r21","r22" ); \
	__syscall_return(type);	                        \
}

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3)		\
type name(type1 arg1,type2 arg2,type3 arg3)			        \
{                                                                       \
	register long _sc_num asm("r15");				\
	register long _sc_res;						\
	register long _sc_arg1 asm("r16");				\
	register long _sc_arg2 asm("r17");				\
	register long _sc_arg3 asm("r18");				\
	register long _sc_err;						\
        _sc_num = __NR_##name;						\
	_sc_arg1 = (long)arg1;						\
	_sc_arg2 = (long)arg2;						\
	_sc_arg3 = (long)arg3;						\
	__asm__ volatile ("syscall 0 \n"				\
			  ";; \n"					\
			  "mfb %0 = $b0 \n"				\
			  "mov %1 = $r16\n"				\
			  ";;\n"					\
			  :"=r" (_sc_err),"=r" (_sc_res)		\
                          : __syscall_input3                             \
			  : __syscall_clobber,"r19","r20","r21","r22" ); \
	__syscall_return(type);						\
}

#define _syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4)\
type name(type1 arg1,type2 arg2,type3 arg3,type4 arg4)   		\
{                                                                       \
	register long _sc_num asm("r15");				\
	register long _sc_res;						\
	register long _sc_arg1 asm("r16");				\
	register long _sc_arg2 asm("r17");				\
	register long _sc_arg3 asm("r18");				\
	register long _sc_arg4 asm("r19");				\
	register long _sc_err;						\
        _sc_num = __NR_##name;						\
	_sc_arg1 = (long)arg1;						\
	_sc_arg2 = (long)arg2;						\
	_sc_arg3 = (long)arg3;						\
	_sc_arg4 = (long)arg4;						\
	__asm__ volatile ("syscall 0 \n"				\
			  ";; \n"					\
			  "mfb %0 = $b0 \n"				\
			  "mov %1 = $r16\n"				\
			  ";;\n"					\
			  :"=r" (_sc_err),"=r" (_sc_res)		\
                          : __syscall_input4				\
			  : __syscall_clobber,"r20","r21","r22"  );	\
	__syscall_return(type);						\
}

#define _syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4,type5,arg5) \
type name(type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5)	\
{                                                                       \
	register long _sc_num asm("r15");				\
	register long _sc_res;						\
	register long _sc_arg1 asm("r16");				\
	register long _sc_arg2 asm("r17");				\
	register long _sc_arg3 asm("r18");				\
	register long _sc_arg4 asm("r19");				\
	register long _sc_arg5 asm("r20");				\
	register long _sc_err;						\
        _sc_num = __NR_##name;						\
	_sc_arg1 = (long)arg1;						\
	_sc_arg2 = (long)arg2;						\
	_sc_arg3 = (long)arg3;						\
	_sc_arg4 = (long)arg4;						\
	_sc_arg5 = (long)arg5;						\
	__asm__ volatile ("syscall 0 \n"				\
			  ";; \n"					\
			  "mfb %0 = $b0 \n"				\
			  "mov %1 = $r16\n"				\
			  ";;\n"					\
			  :"=r" (_sc_err),"=r" (_sc_res)		\
                          : __syscall_input5				\
			  : __syscall_clobber,"r21","r22" );		\
	__syscall_return(type);						\
}

#define _syscall6(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4,type5,arg5,type6,arg6) \
type name(type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5,type6 arg6) \
{                                                                       \
	register long _sc_num asm("r15");				\
	register long _sc_res;						\
	register long _sc_arg1 asm("r16");				\
	register long _sc_arg2 asm("r17");				\
	register long _sc_arg3 asm("r18");				\
	register long _sc_arg4 asm("r19");				\
	register long _sc_arg5 asm("r20");				\
	register long _sc_arg6 asm("r21");				\
	register long _sc_err;						\
        _sc_num = __NR_##name;						\
	_sc_arg1 = (long)arg1;						\
	_sc_arg2 = (long)arg2;						\
	_sc_arg3 = (long)arg3;						\
	_sc_arg4 = (long)arg4;						\
	_sc_arg5 = (long)arg5;						\
	_sc_arg5 = (long)arg6;						\
	__asm__ volatile ("syscall 0 \n"				\
			  ";; \n"					\
			  "mfb %0 = $b0 \n"				\
			  "mov %1 = $r16\n"				\
			  ";;\n"					\
			  :"=r" (_sc_err),"=r" (_sc_res)		\
                          : __syscall_input6				\
			  : __syscall_clobber,"r22");			\
	__syscall_return(type);						\
}

#ifdef __KERNEL_SYSCALLS__

static __inline__ _syscall3(int, execve, const char *, file, char **, argv,
			    char **, envp)
#endif
#ifdef __KERNEL__
#define __ARCH_WANT_STAT64
#define __ARCH_WANT_SYS_LLSEEK
#define __ARCH_WANT_SYS_RT_SIGACTION
#endif
#define __IGNORE_fork		/* use clone */
#define __IGNORE_time
#define __IGNORE_alarm		/* use setitimer */
#define __IGNORE_pause
#define __IGNORE_mmap		/* use mmap2 */
#define __IGNORE_vfork		/* use clone */
#endif				/* __ASSEMBLY__ */
/*
 * "Conditional" syscalls
 */
#define cond_syscall(x) asm("\t.section .text\n\t.weak\t" #x "\n\t.set\t" #x ",sys_ni_syscall\n\t.previous");
#endif				/* _ASM_ST200_UNISTD_H_ */
