/* Any assembly language/system dependent hacks needed to setup boot1.c so it
 * will work as expected and cope with whatever platform specific weirdness is
 * needed for this architecture.
 * 
 * Copyright (C) 2004 ST Microelectronics
 * ST200 port by Carl Shaw (carl.shaw@st.com)
 */

asm("" \
"	.text\n"			\
"	.globl	_dl_boot\n"		\
"_dl_boot:\n"				\
"       # Set up gp                                                        \n"\
"       call    $r0.63 = 0f                                                \n"\
"       ;;                                                                 \n"\
"0:     add     $r0.14 = $r0.63, @neggprel(0b)                             \n"\
"	/*  argc, argv, envp etc are on stack, so we have to preserve */   \n"\
"	/*  them before calling _dl_boot2 */				   \n"\
"	mov 	$r16 = $r12						   \n"\
"	;;								   \n"\
"	add	$r12, $r12, -32						   \n"\
"       ;;                                                                 \n"\
"	call	$r0.63 = _dl_boot2					   \n"\
"	;;								   \n"\
"	add	$r12, $r12, 32						   \n"\
"	mov	$r63 = $r16						   \n"\
"	;;								   \n"\
"	goto	$r63							   \n"\
"	;;								   \n"
);

#define DL_BOOT(X)   void* __attribute_used__ _dl_boot2 (X)
/* was static void* */

/*
 * Get a pointer to the argv array.  On many platforms this can be just
 * the address if the first argument, on other platforms we need to
 * do something a little more subtle here.
 */
#define GET_ARGV(ARGVP, ARGS) ARGVP = ((unsigned long*)   ARGS)

/*
 * Here is a macro to perform a relocation.  This is only used when
 * bootstrapping the dynamic loader.  RELP is the relocation that we
 * are performing, REL is the pointer to the address we are relocating.
 * SYMBOL is the symbol involved in the relocation, and LOAD is the
 * load address.
 */
#define PERFORM_BOOTSTRAP_RELOC(RELP,REL,SYMBOL,LOAD,SYMTAB)	\
	switch(ELF32_R_TYPE((RELP)->r_info)){			\
	case R_LX_NONE:						\
		break;						\
	case R_LX_32:						\
		*(REL)  = (SYMBOL) + (RELP)->r_addend;          \
	        break;                                          \
	case R_LX_32_PCREL:					\
		*(REL)  = (SYMBOL) + (RELP)->r_addend           \
	                    - (unsigned long)(REL);             \
	        break;                                          \
	case R_LX_REL32:					\
		*(REL) = (LOAD) + (RELP)->r_addend;		\
		break;						\
	case R_LX_JMP_SLOT:					\
		*(REL) = (SYMBOL);				\
		break;						\
	default:						\
		SEND_STDERR("BOOTSTRAP_RELOC: unhandled reloc type "); \
		SEND_NUMBER_STDERR(ELF32_R_TYPE((RELP)->r_info), 1); \
		SEND_STDERR("REL, SYMBOL, LOAD: ");		\
		SEND_ADDRESS_STDERR(REL, 0);			\
		SEND_STDERR(", ");				\
		SEND_ADDRESS_STDERR(SYMBOL, 0);			\
		SEND_STDERR(", ");				\
		SEND_ADDRESS_STDERR(LOAD, 1);			\
		_dl_exit(1);					\
	}


/*
 * Transfer control to the user's application, once the dynamic loader
 * is done.  This routine has to exit the current function, then
 * call the _dl_elf_main function.
 */
#define START()   return _dl_elf_main;




