/* vi: set sw=4 ts=4: */
/*
 * Various assmbly language/system dependent  hacks that are required
 * so that we can minimize the amount of platform specific code.
 * Copyright (C) 2000-2004 by Erik Andersen <andersen@codpoet.org>
 * Copyright (C) 2004 ST Microelectronics
 * ST200 port by Carl Shaw (carl.shaw@st.com) 
*/

/* Define this if the system uses RELOCA.  */
#define ELF_USES_RELOCA

/* Initialization sequence for the GOT.  */
#define INIT_GOT(GOT_BASE,MODULE) \
{				\
  GOT_BASE[0] = (unsigned long) MODULE; \
  GOT_BASE[1] = (unsigned long) _dl_linux_resolve; \
}

static inline unsigned long st200_modulus(unsigned long m, unsigned long p)
{
	unsigned long i,t,inc;
	i=p; t=0;
	while(!(i&(1<<31))) {
		i<<=1;
		t++;
	}
	t--;
	for(inc=t;inc>2;inc--) {
		i=p<<inc;
		if(i&(1<<31))
			break;
		while(m>=i) {
			m-=i;
			i<<=1;
			if(i&(1<<31))
				break;
			if(i<p)
				break;
		}
	}
	while(m>=p) {
		m-=p;
	}
	return m;
}
#define do_rem(result, n, base)  result=st200_modulus(n,base);

/* Here we define the magic numbers that this dynamic loader should accept */
#define MAGIC1 EM_LX
#undef  MAGIC2

/* Used for error messages */
#define ELF_TARGET "ST200"

struct elf_resolve;
unsigned long _dl_linux_resolver(struct elf_resolve * tpnt, int reloc_entry);

/* 8192 bytes alignment */
#define PAGE_ALIGN 0xffffe000
#define ADDR_ALIGN 0x1fff
#define OFFS_ALIGN 0x7fffe000
#warning XXX CRS st200 mmap alignment set to 8k

/* ELF_RTYPE_CLASS_PLT iff TYPE describes relocation of a PLT entry or TLS
 *    variable, so undefined references should not be allowed to define the
 *       value.
 *          ELF_RTYPE_CLASS_NOCOPY iff TYPE should not be allowed to resolve to one
 *             of the main executable's symbols, as for a COPY reloc. */
#define elf_machine_type_class(type) \
  (((((type) == R_LX_IPLT) | ((type) == R_LX_JMP_SLOT)) * ELF_RTYPE_CLASS_PLT)\
      | (((type) == R_LX_COPY) * ELF_RTYPE_CLASS_COPY))
