/*
 * ST200 ELF resolve stub (C)2004 ST Microelectronics
 * Written by Carl Shaw (carl.shaw@st.com)
 *
 * This function is _not_ called directly.  It is jumped to (so no return
 * address is on the stack) when attempting to use a symbol that has not yet
 * been resolved.  The first time a jump symbol (such as a function call inside
 * a shared library) is used (before it gets resolved) it will jump here to
 * _dl_linux_resolve.  When we get called the stack looks like this:
 *	reloc_entry
 *	tpnt
 *
 * This function saves all the registers, puts a copy of reloc_entry and tpnt
 * on the stack (as function arguments) then make the function call
 * _dl_linux_resolver(tpnt, reloc_entry).  _dl_linux_resolver() figures out
 * where the jump symbol is _really_ supposed to have jumped to and returns
 * that to us.  Once we have that, we overwrite tpnt with this fixed up
 * address. We then clean up after ourselves, put all the registers back how we
 * found them, then we jump to the fixed up address, which is where the jump
 * symbol that got us here really wanted to jump to in the first place.
 *  -Erik Andersen
 */

#define sp $r12

.text
.globl _dl_linux_resolve
.type _dl_linux_resolve,@function
.proc

_dl_linux_resolve:
	add  sp     = sp, -64
       	;;
       	stw  16[sp] = $r15
       	;;
       	stw  20[sp] = $r16
       	;;
       	stw  24[sp] = $r17
       	;;
       	stw  28[sp] = $r18
       	;;
      	stw  32[sp] = $r19
       	;;
       	stw  36[sp] = $r20
       	;;
       	stw  40[sp] = $r21
       	;;
       	stw  44[sp] = $r22
       	;;
       	stw  48[sp] = $r23
       	;;
       	stw  52[sp] = $r63
	;;
	stw  56[sp] = $r14
	;;
       	mov  $r16     = $r10                                          
      	mov  $r17     = $r9                                           
       	;;                                                                
       	call $r63     = _dl_linux_resolver                                 
       	;;                                                                
	mov  $r63     = $r16
	;;
       	ldw  $r8      = 52[sp]                                      
       	;;                                                                
       	ldw  $r15     = 16[sp]                                      
       	;;                                                                
       	ldw  $r16     = 20[sp]                                      
       	;;                                                                
       	ldw  $r17     = 24[sp]                                      
       	;;                                                                
       	ldw  $r18     = 28[sp]                                      
       	;;                                                                
       	ldw  $r19     = 32[sp]                                      
       	;;                                                                
       	ldw  $r20     = 36[sp]                                      
       	;;                                                                
       	ldw  $r21     = 40[sp]                                      
       	;;                                                                
       	ldw  $r22     = 44[sp]                                      
       	;;                                                                
       	ldw  $r23     = 48[sp]                                      
       	;;                                                                
	ldw  $r14     = 56[sp]
	;;
       	goto $r63                                                       
       	mov  $r63     = $r8                                           
       	add  sp     = sp, +64                                     
       	;;                                                                
.endp                                                             
.previous                                                         
.size _dl_linux_resolve, .-_dl_linux_resolve
