/* Copyright (C) 2002 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

/* clone() is even more special than fork() as it mucks with stacks
   and invokes a function in the right context after its all over.  */

/* 'cris' version allows (child_stack==NULL), which makes the kernel
   allocate stack. Implementing that version, requires the syscall
   returning saved registers to the new thread, since we have no
   stack to store them. */

#include <linux/linkage.h>
#define _ERRNO_H        1
#include <bits/errno.h>
#include <asm/unistd.h>
#include "st200errno.h"

// int __clone(int (*fn)(void *), void *child_stack, int flags, void *arg)

//ENTRY (__clone)
__clone:	
	cmpeq	$b0.0 = $r0.3, 0	/* no NULL function pointers */
	;;
	cmpeq	$b0.1 = $r0.4, 0	/* no NULL stack pointers */
	;;
	br	$b0.0, L?error_einval
	;;
	br	$b0.1, L?error_einval
	add	$r0.4 = $r0.4, -(32	+ 16) /* speculate */ //H +16 because of malloc header and the 24 offset for the function and arguments
	;; 
	stw	24[$r0.4] = $r0.3	/* save user's function ... */
	;;
	stw	20[$r0.4] = $r0.6	/* ... and arguments in the new stack */
	mov	$r0.2 = __NR_clone
	mov	$r0.3 = $r0.5	/* in values for syscall - r17 is ready */
	;;
	trap 0x90 //syscall	0
	;;
	br	$b0.0, L?error
	cmpeq	$b0.0 = $r0.3, $r0.0
	;;
	br	$b0.0, thread_start
	;;
	return	$l0.0
	;;

/* New thread execution latency can be decreased by loading lr in the bundle
 * that follows syscall, no matter which is the sp value. But the code becomes
 * less readable. Do it after debug. */
/* Note: 16 byte scratch area already allocated by parent */
thread_start:
	ldw	$l0.0 = 24[$r0.1]	/* from the new thread's sp */
	;;
	ldw	$r0.3 = 20[$r0.1]
	;;
	call	$l0.0 = $l0.0		/* call the user's function */
	;;
L?1:
#ifdef __PIC__
	/* need to establish our GP so we can call _exit */
	call	$rl0.0 = 1f
	;;
1:	add 	$r0.56 = $l0.0, @neggprel (1b) 
	;;
#endif /* __PIC__ */
	call	$l0.0 = _exit	/* r16 has the return value */
	;; 
	mov	$r0.3 = 1
	goto	L?1
	;;

L?error_einval:
	mov	$r0.3 = EINVAL
	;;

/* errno=r16; return -1; */
L?error:
	/* TODO: fix newlines in ST200ERRNO.h */
	//ST200ERRNO
  	mov	$r0.53 = errno
	stw	0[$r0.53] = $r0.3
	;;
        mov     $r0.3 = -1
	return	$l0.0
        ;;
.size __clone, . - __clone

.weak	clone
	clone	= __clone
