#include <linux/linkage.h>
	
/* When we enter this piece of code, the program stack looks like this:
        argc            argument counter (integer)
        argv[0]         program name (pointer)
        argv[1...N]     program args (pointers)
        argv[argc-1]    end of args (integer)
	NULL
        env[0...N]      environment variables (pointers)
        NULL

	When we are done here, we want
	r16=argc
	r17=argv[0]
	r18=env[0]
*/

#include <features.h>

.section .init
	.global _start
	.type   _start,%function

.section .init
.proc
_start:
##_TOMLBL:
##	goto _TOMLBL
##	;;
	ldw $r0.3 = 0[$r0.1]  /* r16 = argc */
	;;
	add $r0.4 = $r0.1,4   /* r17 = argv[0] */
	;;
	mov $r0.6 = $r0.0 /* These hold destructors/constructors */
	mov $r0.7 = $r0.0 /* latency for r16 */
	;;
	sh2add $r0.5 = $r0.3,$r0.1 /* Calculate envp */ 
	add $r0.1 = $r0.1,-16 /* Allow for scratch stack */
	;;
	add  $r0.5 = $r0.5,8 /* allow for argc, and argv NULL so r18=env[0] */
	call $l0.0 =  __uClibc_start_main /* jump to main() */
	;; 
	call $l0.0 = abort /* Die horribly if we ever come back from here */
	;;
	.endp
		

