#define UART_BASE 0xD1000000
#define UART_DATA (*((volatile unsigned char *)(UART_BASE)))
#define UART_STAT (*((volatile unsigned char *)(UART_BASE+4)))

#define USTAT_TF 2
#define USTAT_DR 8

void serial_putc_raw(const char c)
{
	/* Wait if TX FIFO is full */
	while (!(UART_STAT & USTAT_TF)) ;

	/* Send data */
	UART_DATA = (int)c;

}

void serial_putc(const char c)
{
	if (c == '\n')
		serial_putc_raw('\r');
	if (c == '\r')
		serial_putc_raw('\n');

	serial_putc_raw(c);
}

int serial_getc(void)
{
	/* Wait for a character to arrive. */
	while (!(UART_STAT & USTAT_DR));
	/* read data */
	return UART_DATA;
}

void serial_puts(const char *s)
{
	while (*s) {
		serial_putc(*s++);
	}
}

void lserial_init(void)
{
	return;
}


/* set baud rate for uart */
void lserial_setbaud(void)
{
	return;
}

//needs a 12 bytes sized char array, returns a string repres. of the supplied val.
void tohex(char* s, int val)
{
	int i;
	char tmp;
	int nibble;
	s[0] = '0';
	s[1] = 'x';
	s[10] = '\0';
	s[11] = '\0';
	for(i = 0; i < 8; i++)
	{
		nibble = val&0xF;
		if (nibble > 9)
		{
			tmp = 'A' + nibble - 10;
		}
		else
		{
			tmp = '0'+nibble;
		}
		s[9-i] = tmp;
		val >>= 4;
	}
}


