/* libc/sysdeps/linux/st200/_mmap.c
 * mmap() code for st200
 *
 * Copyright (C) 2003 by STMicroelectronics Limited
 * Author: Antonio Borneo <stuart.menefy@st.com>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <unistd.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/syscall.h>
#include <sys/param.h>

#define MMAP2_PAGE_SHIFT 12

#define __NR__mmap2 __NR_mmap2
_syscall6 (__ptr_t, _mmap2, __ptr_t, addr, size_t, len, int, prot,
           int, flags, int, fd, unsigned long, pgoff);

void *mmap(void *addr, size_t len, int prot, int flags, int fd, off_t offset)
{
  if (offset & ((1 << MMAP2_PAGE_SHIFT) - 1)) 
  {
    __set_errno (EINVAL);
    return MAP_FAILED;
  }

  return _mmap2(addr, len, prot, flags, fd, offset >> MMAP2_PAGE_SHIFT);
}
