/*
 * libc/sysdeps/linux/st200/ptrace.c
 *
 * ptrace() code for ST200.
 * We don't need to do anything special for ST200.
 *
 * Copyright (C) 2002 by STMicroelectronics
 * Author: Stuart Menefy <stuart.menefy@st.com>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#define _GNU_SOURCE
#include <unistd.h>
#include <errno.h>
#include <sys/syscall.h>

/* The sys/ptrace.h defintion of ptrace doesn't match the one we need here */
#define ptrace xptrace
#include <sys/ptrace.h>
#undef ptrace

_syscall4(long, ptrace, enum __ptrace_request, request, pid_t, pid,
	  void*, addr, void*, data);
