#include <asm/system.h>

#include "pt-machine.h"

/* Spinlock implementation; required.  */
long int testandset (int *spinlock){
    volatile int tmp;
    unsigned long flags;
    
    /* disable interupts */
    save_flags(flags);
    cli();
    
    /* test and set */
    tmp = *spinlock;
    *spinlock = 1;

    /* enable interupts */
    restore_flags(flags);

    return tmp;
}

int __compare_and_swap (long int *p, long int oldval,
    long int newval){
    volatile int ret;
    unsigned long flags;
       
    /* disable interupts */
    save_flags(flags);
    cli();
    
    /* compare and swap */
    if ( *p != oldval ) ret = 0;
    
    else{
        *p = newval;
        ret = 1;
    }

    /* enable interupts */
    restore_flags(flags);

    return ret;
}
