/* libpthread/linuxthreads/sysdeps/st200/pt-machine.h
 * Machine-dependent pthreads configuration and inline functions.
 * st200 version.
 *
 * Copyright (C) 2002, 2003, 2004 by STMicroelectronics
 * Author: Carl Shaw <carl.shaw@st.com>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef _PT_MACHINE_H
#define _PT_MACHINE_H   1

#ifndef __ASSEMBLER__

#ifndef PT_EI
# define PT_EI extern inline
#endif

/*  ST200 cannot have "M" constraint on inline asm */
#define UCLIB_NO_M_CONSTRAINT 1
extern long int testandset (int *spinlock);

extern int __compare_and_swap (long int *p, long int oldval,
			       long int newval);

/* Get some notion of the current stack.  Need not be exactly the top
   of the stack, just something somewhere in the current frame.  */
#define CURRENT_STACK_FRAME  stack_pointer
register char *stack_pointer __asm__("r0.1");

/*
PT_EI long int
testandset (int *spinlock)
{
  volatile unsigned int tmp;

  asm volatile ("	call $l0.0 = 1f\n"
		"	;;\n"
		"1:	mov $r0.56 = $l0.0\n"
		"	or $r0.1, $r0.1, 1\n"
		"	ldw %0 = 0 [ %1 ]\n"
		"	;;\n"
		"	stw 0[ %1 ] = $r0.56\n"
		"	and $r0.1 = $r0.1,~1"
                : "=&r" (tmp)
                : "r" (spinlock)
                : "memory", "r0.1", "l0.0");

  return (tmp == 0) ? 0 : 1;
}
*/
#endif /* __ASSEMBLER */
#endif /* _PT_MACHINE_H */
