-- This file is generated by the scripts in rvex-hdl.git/cgen/bin. --

-- r-VEX processor                                                                                   -- GENERATED --
-- Copyright (C) 2008-2018 by TU Delft.
-- All Rights Reserved.

-- THIS IS A LEGAL DOCUMENT, BY USING r-VEX,
-- YOU ARE AGREEING TO THESE TERMS AND CONDITIONS.

-- No portion of this work may be used by any commercial entity, or for any
-- commercial purpose, without the prior, written permission of TU Delft.
-- Nonprofit and noncommercial use is permitted as described below.
                                                                                                     -- GENERATED --
-- 1. r-VEX is provided AS IS, with no warranty of any kind, express
-- or implied. The user of the code accepts full responsibility for the
-- application of the code and the use of any results.

-- 2. Nonprofit and noncommercial use is encouraged. r-VEX may be
-- downloaded, compiled, synthesized, copied, and modified solely for nonprofit,
-- educational, noncommercial research, and noncommercial scholarship
-- purposes provided that this notice in its entirety accompanies all copies.
-- Copies of the modified software can be delivered to persons who use it
-- solely for nonprofit, educational, noncommercial research, and                                    -- GENERATED --
-- noncommercial scholarship purposes provided that this notice in its
-- entirety accompanies all copies.

-- 3. ALL COMMERCIAL USE, AND ALL USE BY FOR PROFIT ENTITIES, IS EXPRESSLY
-- PROHIBITED WITHOUT A LICENSE FROM TU Delft (J.S.S.M.Wong@tudelft.nl).

-- 4. No nonprofit user may place any restrictions on the use of this software,
-- including as modified by the user, by any other authorized user.

-- 5. Noncommercial and nonprofit users may distribute copies of r-VEX                               -- GENERATED --
-- in compiled or binary form as set forth in Section 2, provided that
-- either: (A) it is accompanied by the corresponding machine-readable source
-- code, or (B) it is accompanied by a written offer, with no time limit, to
-- give anyone a machine-readable copy of the corresponding source code in
-- return for reimbursement of the cost of distribution. This written offer
-- must permit verbatim duplication by anyone, or (C) it is distributed by
-- someone who received only the executable form, and is accompanied by a
-- copy of the written offer of source code.

-- 6. r-VEX was developed by Stephan Wong, Thijs van As, Fakhar Anjam,                               -- GENERATED --
-- Roel Seedorf, Anthony Brandon, Jeroen van Straten. r-VEX is currently
-- maintained by TU Delft (J.S.S.M.Wong@tudelft.nl).

-- Copyright (C) 2008-2018 by TU Delft.

library IEEE;
use IEEE.std_logic_1164.all;

library work;
use work.core_intIface_pkg.all;                                                                      -- GENERATED --
use work.core_opcodeDatapath_pkg.all;
use work.core_opcodeAlu_pkg.all;
use work.core_opcodeBranch_pkg.all;
use work.core_opcodeMemory_pkg.all;
use work.core_opcodeMultiplier_pkg.all;
use work.core_opcodeFpu_pkg.all;

--=============================================================================
-- This package specifies basic decoding signals for all opcodes. In theory,
-- when you want to implement a new instruction which makes use of existing                          -- GENERATED --
-- logic in the pipelanes, you only need to change things here and in the
-- rvex_opcode<unit>_pkg associated with the unit you want to change. If you
-- also need new control signals, you'll obviously have to change the code of
-- the functional unit as well.
-------------------------------------------------------------------------------
package core_opcode_pkg is
--=============================================================================

  -----------------------------------------------------------------------------
  -- Misc. instruction set constants                                                                 -- GENERATED --
  -----------------------------------------------------------------------------
  -- Special "general purpose" register which is always tied to 0.
  constant GPREG_ZERO           : rvex_gpRegAddr_type := "000000";

  -- Special "general purpose" register which is used as stack pointer by
  -- return instructions.
  constant GPREG_STACK          : rvex_gpRegAddr_type := "000001";

  -- Special "general purpose" register which optionally maps to the link
  -- register, based on configuration.                                                               -- GENERATED --
  constant GPREG_LINK           : rvex_gpRegAddr_type := "111111";

  -- Determines which encoding is used for the relative branch offset. May be
  -- set to 2 or 3. When set to 3, the old encoding is used, where the LSB of
  -- the branch offset is equal to 64 bits. When set to 2, the branch offset
  -- is shifted right by one bit, to allow branching to 32 bit boundaries.
  constant BRANCH_OFFS_SHIFT    : natural := 3;

  -----------------------------------------------------------------------------
  -- Opcode table entry type                                                                         -- GENERATED --
  -----------------------------------------------------------------------------
  -- Constrained string type for syntax specifications.
  subtype syllable_syntax_type is string(1 to 50);

  -- Each opcode has a table entry like this which defines the behavior of the
  -- instruction.
  type opcodeTableEntry_type is record

    -- Instruction name/syntax for disassembly in VHDL simulation. Syntax_reg
    -- is for syllables with bit 23 cleared, syntax_imm is for syllables with                        -- GENERATED --
    -- bit 23 set. See also the documentation just below the =Opcode decoding
    -- table= header.
    syntax_reg                  : syllable_syntax_type;
    syntax_imm                  : syllable_syntax_type;

    -- Instruction valid. When this is low, attempting to execute this
    -- instruction raises an invalid instruction exception. This is indexed
    -- by bit 23 of the syllable, which determines whether operand 2 is a
    -- register or an immediate.
    valid                       : std_logic_vector(1 downto 0);                                      -- GENERATED --

    -- Control signals for datapath.
    datapathCtrl                : datapathCtrlSignals_type;

    -- Control signals for the ALU.
    aluCtrl                     : aluCtrlSignals_type;

    -- Control signals for the branch unit.
    branchCtrl                  : branchCtrlSignals_type;
                                                                                                     -- GENERATED --
    -- Control signals for the memory unit.
    memoryCtrl                  : memoryCtrlSignals_type;

    -- Control signals for the multiplier unit.
    multiplierCtrl              : multiplierCtrlSignals_type;

    -- Control signals for the FPU.
    fpuCtrl                     : fpuCtrlSignals_type;

  end record;                                                                                        -- GENERATED --

  -- Array type of the above to get a table. The index of this table is the
  -- opcode (the MSB of the syllable).
  type opcodeTable_type is array (0 to 2**rvex_opcode_type'LENGTH-1) of opcodeTableEntry_type;

  --===========================================================================
  -- Opcode decoding table
  --===========================================================================
  -- This table specifies how all instructions are decoded. It is generated by
  -- the scripts in the config directory.                                                            -- GENERATED --
  --
  -- Indexes in this table correspond to syllable bit 31 downto 24. The syntax
  -- formatter makes the following replacements when decoding the instruction.
  --   "%r1" --> Bit 22..17 in unsigned decimal.
  --   "%r2" --> Bit 16..11 in unsigned decimal.
  --   "%r3" --> Bit 10..5 in unsigned decimal.
  --   "%id" --> immediate, respecting long immediates. Displays the immediate
  --             in signed decimal form.
  --   "%iu" --> Same as above, but in unsigned decimal form.
  --   "%ih" --> Same as above, but in hex form.                                                     -- GENERATED --
  --   "%i1" --> Bit 27..25 in unsigned decimal for LIMMH target lane.
  --   "%i2" --> Bit 24..02 in hex for LIMMH.
  --   "%b1" --> Bit 26..24 in unsigned decimal.
  --   "%b2" --> Bit 19..17 in unsigned decimal.
  --   "%b3" --> Bit 4..2 in unsigned decimal.
  --   "%bi" --> Bit 23..5 in signed decimal (rfi/return stack offset).
  --   "%bt" --> Next PC + bit 23..5 in hex (branch target).
  --   "#"   --> Cluster identifier (maps to 0).

                                                                                                     -- GENERATED --
  -----------------------------------------------------------------------------
  -- Undefined entries
  -----------------------------------------------------------------------------
  constant opcodeTableEntry_default : opcodeTableEntry_type := (
    syntax_reg => "unknown                                           ",
    syntax_imm => "unknown                                           ",
    valid => "00", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
    brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
    enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
    enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',                        -- GENERATED --
    gpRegWE => '0', isLIMMH => '0', isNOP => '1', isTrap => '0', linkWE => '0',
    op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
    aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
    divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
    opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
    fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
    isFCompareInstruction => '0', isFConvfiInstruction => '0',
    isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
    branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
    branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                      -- GENERATED --
    memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
    isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
    writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
    op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
    op2unsigned => '0', resultSel => PASS)
  );

  constant OPCODE_TABLE : opcodeTable_type := (

    ---------------------------------------------------------------------------                      -- GENERATED --
    -- ALU arithmetic instructions
    ---------------------------------------------------------------------------
    98 => (
      syntax_reg => "add r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "add r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    107 => (
      syntax_reg => "sh1add r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "sh1add r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => SHL1, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    108 => (
      syntax_reg => "sh2add r#.%r1 = r#.%r2, r#.%r3                    ",                            -- GENERATED --
      syntax_imm => "sh2add r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => SHL2, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),                                        -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    109 => (
      syntax_reg => "sh3add r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "sh3add r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => SHL3, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    110 => (
      syntax_reg => "sh4add r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "sh4add r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => SHL4, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    26 => (
      syntax_reg => "sub r#.%r1 = r#.%r3, r#.%r2                       ",
      syntax_imm => "sub r#.%r1 = %ih, r#.%r2                          ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    120 to 127 => (
      syntax_reg => "addcg r#.%r1, b#.%b3 = b#.%b1, r#.%r2, r#.%r3     ",
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CARRY_OUT, compare => '0',                   -- GENERATED --
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    112 to 119 => (
      syntax_reg => "divs r#.%r1, b#.%b3 = b#.%b1, r#.%r2, r#.%r3      ",
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => DIVS, compare => '0',
      divs => '1', intResultMux => ADDER, op1Mux => SHL1, op2Mux => EXTEND32,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),

    ---------------------------------------------------------------------------
    -- ALU barrel shifter instructions
    ---------------------------------------------------------------------------                      -- GENERATED --
    111 => (
      syntax_reg => "shl r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "shl r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',                        -- GENERATED --
      divs => '0', intResultMux => SHIFTER, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '1', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    24 => (
      syntax_reg => "shr r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "shr r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => SHIFTER, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    25 => (
      syntax_reg => "shru r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "shru r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => SHIFTER, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
                                                                                                     -- GENERATED --
    ---------------------------------------------------------------------------
    -- ALU bitwise instructions
    ---------------------------------------------------------------------------
    99 => (
      syntax_reg => "and r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "and r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    100 => (
      syntax_reg => "andc r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "andc r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    105 => (                                                                                         -- GENERATED --
      syntax_reg => "or r#.%r1 = r#.%r2, r#.%r3                        ",
      syntax_imm => "or r#.%r1 = r#.%r2, %ih                           ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32,                                      -- GENERATED --
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    106 => (
      syntax_reg => "orc r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "orc r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    31 => (
      syntax_reg => "xor r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "xor r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_XOR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),

    ---------------------------------------------------------------------------                      -- GENERATED --
    -- ALU single-bit instructions
    ---------------------------------------------------------------------------
    44 => (
      syntax_reg => "sbit r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "sbit r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => SET_BIT, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    45 => (
      syntax_reg => "sbitf r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "sbitf r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => SET_BIT, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    92 => (
      syntax_reg => "tbit r#.%r1 = r#.%r2, r#.%r3                      ",                            -- GENERATED --
      syntax_imm => "tbit r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => TBIT, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),                                        -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    93 => (
      syntax_reg => "tbit b#.%b2 = r#.%r2, r#.%r3                      ",
      syntax_imm => "tbit b#.%b2 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => TBIT, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    94 => (
      syntax_reg => "tbitf r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "tbitf r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => TBITF, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    95 => (
      syntax_reg => "tbitf b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "tbitf b#.%b2 = r#.%r2, %ih                        ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => TBITF, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --

    ---------------------------------------------------------------------------
    -- ALU boolean instructions
    ---------------------------------------------------------------------------
    90 => (
      syntax_reg => "andl r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "andl r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_AND, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    91 => (
      syntax_reg => "andl b#.%b2 = r#.%r2, r#.%r3                      ",
      syntax_imm => "andl b#.%b2 = r#.%r2, %ih                         ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_AND, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    88 => (
      syntax_reg => "orl r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "orl r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_OR, compare => '0',                    -- GENERATED --
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    89 => (
      syntax_reg => "orl b#.%b2 = r#.%r2, r#.%r3                       ",
      syntax_imm => "orl b#.%b2 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_OR, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    84 => (
      syntax_reg => "nandl r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "nandl r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_NAND,
      compare => '0', divs => '0', intResultMux => BOOL, op1Mux => EXTEND32,
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    85 => (                                                                                          -- GENERATED --
      syntax_reg => "nandl b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "nandl b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_NAND,
      compare => '0', divs => '0', intResultMux => BOOL, op1Mux => EXTEND32,                         -- GENERATED --
      op2Mux => EXTEND32, opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    86 => (
      syntax_reg => "norl r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "norl r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_NOR, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    87 => (
      syntax_reg => "norl b#.%b2 = r#.%r2, r#.%r3                      ",
      syntax_imm => "norl b#.%b2 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => LOGIC_NOR, compare => '0',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),

    ---------------------------------------------------------------------------                      -- GENERATED --
    -- ALU compare instructions
    ---------------------------------------------------------------------------
    64 => (
      syntax_reg => "cmpeq r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpeq r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_EQ, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    65 => (
      syntax_reg => "cmpeq b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpeq b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_EQ, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    66 => (
      syntax_reg => "cmpge r#.%r1 = r#.%r2, r#.%r3                     ",                            -- GENERATED --
      syntax_imm => "cmpge r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),                     -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    67 => (
      syntax_reg => "cmpge b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpge b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    68 => (
      syntax_reg => "cmpgeu r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgeu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    69 => (
      syntax_reg => "cmpgeu b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgeu b#.%b2 = r#.%r2, %ih                       ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    70 => (
      syntax_reg => "cmpgt r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpgt r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GT, compare => '1',                      -- GENERATED --
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    71 => (
      syntax_reg => "cmpgt b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpgt b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    72 => (
      syntax_reg => "cmpgtu r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgtu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    73 => (                                                                                          -- GENERATED --
      syntax_reg => "cmpgtu b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgtu b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,                                      -- GENERATED --
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    74 => (
      syntax_reg => "cmple r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmple r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    75 => (
      syntax_reg => "cmple b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmple b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    76 => (
      syntax_reg => "cmpleu r#.%r1 = r#.%r2, r#.%r3                    ",                            -- GENERATED --
      syntax_imm => "cmpleu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),                     -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    77 => (
      syntax_reg => "cmpleu b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpleu b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    78 => (
      syntax_reg => "cmplt r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmplt r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    79 => (
      syntax_reg => "cmplt b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmplt b#.%b2 = r#.%r2, %ih                        ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    80 => (
      syntax_reg => "cmpltu r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpltu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LT, compare => '1',                      -- GENERATED --
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    81 => (
      syntax_reg => "cmpltu b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpltu b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LT, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    82 => (
      syntax_reg => "cmpne r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpne r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_NE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    83 => (                                                                                          -- GENERATED --
      syntax_reg => "cmpne b#.%b2 = r#.%r2, r#.%r3                     ",
      syntax_imm => "cmpne b#.%b2 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_NE, compare => '1',
      divs => '0', intResultMux => BOOL, op1Mux => EXTEND32INV,                                      -- GENERATED --
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),

    ---------------------------------------------------------------------------
    -- ALU selection instructions
    ---------------------------------------------------------------------------
    56 to 63 => (
      syntax_reg => "slct r#.%r1 = b#.%b1, r#.%r2, r#.%r3              ",
      syntax_imm => "slct r#.%r1 = b#.%b1, r#.%r2, %ih                 ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    48 to 55 => (                                                                                    -- GENERATED --
      syntax_reg => "slctf r#.%r1 = b#.%b1, r#.%r2, r#.%r3             ",
      syntax_imm => "slctf r#.%r1 = b#.%b1, r#.%r2, %ih                ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32, op2Mux => EXTEND32,                   -- GENERATED --
      opBrMux => INVERT, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    101 => (
      syntax_reg => "max r#.%r1 = r#.%r2, r#.%r3                       ",
      syntax_imm => "max r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    102 => (
      syntax_reg => "maxu r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "maxu r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_GE, compare => '1',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    103 => (
      syntax_reg => "min r#.%r1 = r#.%r2, r#.%r3                       ",                            -- GENERATED --
      syntax_imm => "min r#.%r1 = r#.%r2, %ih                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '0'),                     -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    104 => (
      syntax_reg => "minu r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "minu r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => CMP_LE, compare => '1',
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32INV,
      op2Mux => EXTEND32, opBrMux => TRUE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),

    ---------------------------------------------------------------------------
    -- ALU type conversion instructions
    ---------------------------------------------------------------------------
    27 => (
      syntax_reg => "sxtb r#.%r1 = r#.%r2                              ",                            -- GENERATED --
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND8, op2Mux => ZERO,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),                                        -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    28 => (
      syntax_reg => "sxth r#.%r1 = r#.%r2                              ",
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND16, op2Mux => ZERO,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    29 => (
      syntax_reg => "zxtb r#.%r1 = r#.%r2                              ",
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND8, op2Mux => ZERO,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    30 => (
      syntax_reg => "zxth r#.%r1 = r#.%r2                              ",
      syntax_imm => "unknown                                           ",                            -- GENERATED --
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND16, op2Mux => ZERO,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '1'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --

    ---------------------------------------------------------------------------
    -- ALU miscellaneous instructions
    ---------------------------------------------------------------------------
    96 => (
      syntax_reg => "nop                                               ",
      syntax_imm => "nop                                               ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '1', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    145 => (
      syntax_reg => "clz r#.%r1 = r#.%r2                               ",
      syntax_imm => "unknown                                           ",                            -- GENERATED --
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '1',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => CLZ, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    11 => (
      syntax_reg => "movtl l#.0 = r#.%r3                               ",
      syntax_imm => "movtl l#.0 = %ih                                  ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '1',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',                         -- GENERATED --
      divs => '0', intResultMux => OP_SEL, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    12 => (
      syntax_reg => "movfl r#.%r1 = l#.0                               ",
      syntax_imm => "unknown                                           ",
      valid => "01", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '1', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    144 => (
      syntax_reg => "trap r#.%r2, r#.%r3                               ",
      syntax_imm => "trap r#.%r2, %ih                                  ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '1', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
                                                                                                     -- GENERATED --
    ---------------------------------------------------------------------------
    -- Multiply instructions
    ---------------------------------------------------------------------------
    0 => (
      syntax_reg => "mpyll r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpyll r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    1 => (
      syntax_reg => "mpyllu r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "mpyllu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => LOW_HALF, op1unsigned => '1', op2sel => LOW_HALF,
      op2unsigned => '1', resultSel => PASS)
    ),
    2 => (                                                                                           -- GENERATED --
      syntax_reg => "mpylh r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpylh r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,                      -- GENERATED --
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => HIGH_HALF,                                   -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    3 => (
      syntax_reg => "mpylhu r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "mpylhu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => LOW_HALF, op1unsigned => '1', op2sel => HIGH_HALF,
      op2unsigned => '1', resultSel => PASS)
    ),
    4 => (
      syntax_reg => "mpyhh r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpyhh r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => HIGH_HALF, op1unsigned => '0', op2sel => HIGH_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    5 => (
      syntax_reg => "mpyhhu r#.%r1 = r#.%r2, r#.%r3                    ",                            -- GENERATED --
      syntax_imm => "mpyhhu r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),                                         -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => HIGH_HALF, op1unsigned => '1', op2sel => HIGH_HALF,
      op2unsigned => '1', resultSel => PASS)                                                         -- GENERATED --
    ),
    6 => (
      syntax_reg => "mpyl r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "mpyl r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '0', op2sel => LOW_HALF, op2unsigned => '0',
      resultSel => PASS)
    ),
    7 => (
      syntax_reg => "mpylu r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpylu r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '1', op2sel => LOW_HALF, op2unsigned => '1',
      resultSel => PASS)
    ),
    8 => (
      syntax_reg => "mpyh r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "mpyh r#.%r1 = r#.%r2, %ih                         ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '0', op2sel => HIGH_HALF, op2unsigned => '0',
      resultSel => PASS)
    ),                                                                                               -- GENERATED --
    9 => (
      syntax_reg => "mpyhu r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpyhu r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',                         -- GENERATED --
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',                          -- GENERATED --
      op1sel => WORD, op1unsigned => '1', op2sel => HIGH_HALF, op2unsigned => '1',
      resultSel => PASS)
    ),
    10 => (
      syntax_reg => "mpyhs r#.%r1 = r#.%r2, r#.%r3                     ",
      syntax_imm => "mpyhs r#.%r1 = r#.%r2, %ih                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '0', op2sel => HIGH_HALF, op2unsigned => '0',
      resultSel => SHL16)
    ),
    146 => (
      syntax_reg => "mpylhus r#.%r1 = r#.%r2, r#.%r3                   ",
      syntax_imm => "mpylhus r#.%r1 = r#.%r2, %ih                      ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '0', op2sel => LOW_HALF, op2unsigned => '1',
      resultSel => SHR32)
    ),
    147 => (                                                                                         -- GENERATED --
      syntax_reg => "mpyhhs r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "mpyhhs r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '1', funcSel => MUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,                      -- GENERATED --
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '1',
      op1sel => WORD, op1unsigned => '0', op2sel => HIGH_HALF, op2unsigned => '0',                   -- GENERATED --
      resultSel => SHR16)
    ),

    ---------------------------------------------------------------------------
    -- Floating-point instructions
    ---------------------------------------------------------------------------
    151 => (
      syntax_reg => "addf r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "addf r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '0', enableFAdd => '1', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FADD, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '1',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    152 => (                                                                                         -- GENERATED --
      syntax_reg => "subf r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "subf r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '1', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FADD, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,                      -- GENERATED --
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => SUBTRACT, cmpOp => EQ, isFAddInstruction => '1',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    153 => (
      syntax_reg => "mpyf r#.%r1 = r#.%r2, r#.%r3                      ",
      syntax_imm => "mpyf r#.%r1 = r#.%r2, %ih                         ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '1', enableMem => '0',
      enableMul => '0', funcSel => FMUL, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '1', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    154 => (
      syntax_reg => "cmpgef r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgef r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => GE, isFAddInstruction => '0',
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    155 => (
      syntax_reg => "cmpgef b#.%b2 = r#.%r2, r#.%r3                    ",                            -- GENERATED --
      syntax_imm => "cmpgef b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),                                         -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => GE, isFAddInstruction => '0',
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    156 => (
      syntax_reg => "cmpeqf r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpeqf r#.%r1 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    157 => (
      syntax_reg => "cmpeqf b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpeqf b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    158 => (
      syntax_reg => "cmpgtf r#.%r1 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgtf r#.%r1 = r#.%r2, %ih                       ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => GT, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    159 => (
      syntax_reg => "cmpgtf b#.%b2 = r#.%r2, r#.%r3                    ",
      syntax_imm => "cmpgtf b#.%b2 = r#.%r2, %ih                       ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '1', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '1', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCMP, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',                         -- GENERATED --
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => GT, isFAddInstruction => '0',
      isFCompareInstruction => '1', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    149 => (
      syntax_reg => "convif r#.%r1 = r#.%r2                            ",
      syntax_imm => "convif r#.%r1 = r#.%r2                            ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '1', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCIF, gpRegRdEnaA => '1', gpRegRdEnaB => '0',                     -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '1', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    150 => (
      syntax_reg => "convfi r#.%r1 = r#.%r2                            ",
      syntax_imm => "convfi r#.%r1 = r#.%r2                            ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '1',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => FCFI, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '1',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
                                                                                                     -- GENERATED --
    ---------------------------------------------------------------------------
    -- Memory instructions
    ---------------------------------------------------------------------------
    16 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldw r#.%r1 = %ih[r#.%r2]                          ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    17 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldh r#.%r1 = %ih[r#.%r2]                          ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_HALFWORD,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    18 => (                                                                                          -- GENERATED --
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldhu r#.%r1 = %ih[r#.%r2]                         ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,                    -- GENERATED --
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_HALFWORD,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '1',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    19 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldb r#.%r1 = %ih[r#.%r2]                          ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_BYTE,                                            -- GENERATED --
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    20 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldbu r#.%r1 = %ih[r#.%r2]                         ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_BYTE,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '1',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    13 => (
      syntax_reg => "unknown                                           ",                            -- GENERATED --
      syntax_imm => "ldw l#.0 = %ih[r#.%r2]                            ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '1',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),                                        -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    46 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "ldbr %ih[r#.%r2]                                  ",
      valid => "10", datapathCtrl => (allBrRegsWE => '1', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => MEM, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_BYTE,
      isMemoryInstruction => '1', readEnable => '1', unsignedOp => '1',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    21 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "stw %ih[r#.%r2] = r#.%r1                          ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '1', readEnable => '0', unsignedOp => '0',
      writeEnable => '1'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    22 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "sth %ih[r#.%r2] = r#.%r1                          ",                            -- GENERATED --
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_HALFWORD,
      isMemoryInstruction => '1', readEnable => '0', unsignedOp => '0',
      writeEnable => '1'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --
    23 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "stb %ih[r#.%r2] = r#.%r1                          ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',                        -- GENERATED --
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_BYTE,
      isMemoryInstruction => '1', readEnable => '0', unsignedOp => '0',
      writeEnable => '1'), multiplierCtrl => (isMultiplyInstruction => '0',                          -- GENERATED --
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    14 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "stw %ih[r#.%r2] = l#.0                            ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',                      -- GENERATED --
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '1', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '1', readEnable => '0', unsignedOp => '0',
      writeEnable => '1'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    47 => (
      syntax_reg => "unknown                                           ",
      syntax_imm => "stbr %ih[r#.%r2]                                  ",
      valid => "10", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '1',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '1',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '1', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_BYTE,
      isMemoryInstruction => '1', readEnable => '0', unsignedOp => '0',
      writeEnable => '1'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
                                                                                                     -- GENERATED --
    ---------------------------------------------------------------------------
    -- Branch instructions
    ---------------------------------------------------------------------------
    32 => (
      syntax_reg => "goto %bt                                          ",
      syntax_imm => "goto %bt                                          ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',                      -- GENERATED --
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '1',
      branchToLink => '0', isBranchInstruction => '1', link => '0', stop => '0'),                    -- GENERATED --
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    33 => (
      syntax_reg => "igoto l#.0                                        ",
      syntax_imm => "igoto l#.0                                        ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',                              -- GENERATED --
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',                                     -- GENERATED --
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '1',
      branchToLink => '1', isBranchInstruction => '1', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    34 => (                                                                                          -- GENERATED --
      syntax_reg => "call l#.0 = %bt                                   ",
      syntax_imm => "call l#.0 = %bt                                   ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => PCP1, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '1',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,                      -- GENERATED --
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '1',
      branchToLink => '0', isBranchInstruction => '1', link => '1', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,                                    -- GENERATED --
      op2unsigned => '0', resultSel => PASS)
    ),
    35 => (
      syntax_reg => "icall l#.0 = l#.0                                 ",
      syntax_imm => "icall l#.0 = l#.0                                 ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => PCP1, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '1',                    -- GENERATED --
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '1',
      branchToLink => '1', isBranchInstruction => '1', link => '1', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,                                            -- GENERATED --
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    36 => (
      syntax_reg => "br b#.%b3, %bt                                    ",
      syntax_imm => "br b#.%b3, %bt                                    ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',                        -- GENERATED --
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),                     -- GENERATED --
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '1',
      branchToLink => '0', isBranchInstruction => '1', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    37 => (
      syntax_reg => "brf b#.%b3, %bt                                   ",                            -- GENERATED --
      syntax_imm => "brf b#.%b3, %bt                                   ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),                                         -- GENERATED --
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '1', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)                                                         -- GENERATED --
    ),
    38 => (
      syntax_reg => "return r#.1 = r#.1, %bi, l#.0                     ",
      syntax_imm => "return r#.1 = r#.1, %bi, l#.0                     ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '1'),                   -- GENERATED --
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '1', branchIfTrue => '1',
      branchToLink => '1', isBranchInstruction => '1', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',                              -- GENERATED --
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    39 => (
      syntax_reg => "rfi r#.1 = r#.1, %bi                              ",
      syntax_imm => "rfi r#.1 = r#.1, %bi                              ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '1', gpRegRdEnaB => '0',
      gpRegWE => '1', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '1'),
      aluCtrl => (bitwiseOp => BITW_AND, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => ADDER, op1Mux => EXTEND32, op2Mux => EXTEND32,
      opBrMux => FALSE, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '1', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '1', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    40 => (
      syntax_reg => "stop                                              ",
      syntax_imm => "stop                                              ",                            -- GENERATED --
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '1', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '0', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',                               -- GENERATED --
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',
      branchToLink => '0', isBranchInstruction => '1', link => '0', stop => '1'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),                                                                                               -- GENERATED --

    ---------------------------------------------------------------------------
    -- Long immediate instructions
    ---------------------------------------------------------------------------
    128 to 143 => (
      syntax_reg => "limmh %i1, %i2                                    ",
      syntax_imm => "limmh %i1, %i2                                    ",
      valid => "11", datapathCtrl => (allBrRegsWE => '0', brFmt => '0',
      brRegWE => '0', enableALU => '0', enableFAdd => '0', enableFCfi => '0',
      enableFCif => '0', enableFCmp => '0', enableFMul => '0', enableMem => '0',                     -- GENERATED --
      enableMul => '0', funcSel => ALU, gpRegRdEnaA => '0', gpRegRdEnaB => '0',
      gpRegWE => '0', isLIMMH => '1', isNOP => '0', isTrap => '0', linkWE => '0',
      op1LinkReg => '0', op3BranchRegs => '0', op3LinkReg => '0', stackOp => '0'),
      aluCtrl => (bitwiseOp => BITW_OR, brResultMux => PASS, compare => '0',
      divs => '0', intResultMux => BITWISE, op1Mux => EXTEND32, op2Mux => ZERO,
      opBrMux => PASS, shiftLeft => '0', unsignedOp => '0'),
      fpuCtrl => (addOp => ADD, cmpOp => EQ, isFAddInstruction => '0',
      isFCompareInstruction => '0', isFConvfiInstruction => '0',
      isFConvifInstruction => '0', isFMulInstruction => '0', unsignedOp => '0'),
      branchCtrl => (RFI => '0', branchIfFalse => '0', branchIfTrue => '0',                          -- GENERATED --
      branchToLink => '0', isBranchInstruction => '0', link => '0', stop => '0'),
      memoryCtrl => (accessSizeBLog2 => ACCESS_SIZE_WORD,
      isMemoryInstruction => '0', readEnable => '0', unsignedOp => '0',
      writeEnable => '0'), multiplierCtrl => (isMultiplyInstruction => '0',
      op1sel => LOW_HALF, op1unsigned => '0', op2sel => LOW_HALF,
      op2unsigned => '0', resultSel => PASS)
    ),
    others => opcodeTableEntry_default
  );
                                                                                                     -- GENERATED --
end core_opcode_pkg;

package body core_opcode_pkg is
end core_opcode_pkg;
